freeslot("SFX_WINCBT", "SFX_WINXBT", "SFX_WINRBT")

sfxinfo[sfx_wincbt] = {
        singular = false,
        priority = 50,
		caption = "DirectX Boost"
}

sfxinfo[sfx_winxbt] = {
        singular = false,
        priority = 51,
		caption = "DirectX Boost"
}

sfxinfo[sfx_winrbt] = {
        singular = false,
        priority = 50,
		caption = "DirectX Ready"
}

for player in players.iterate
	player.winpopup = 15*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
end

local directxboost = CV_RegisterVar({ // Toggle for the miniboost ability.
	name = "DirectX",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = CV_YesNo
})

local mobjscale = CV_RegisterVar({ 
	name = "kartgrow",					// Console variable to keep track
	defaultvalue = 1,					// for speed shoes replacement
	flags = CV_NETVAR | CV_SHOWMODIF,	// mechanic straight from SRB2Kart.
	PossibleValue = CV_YesNo
})

// Set up a value to check against for custom jingles.
local mplayer = CV_RegisterVar({
	name = "canyon.mid",
	defaultvalue = 1,
	flags = CV_SHOWMODIF,
	PossibleValue = CV_YesNo
})

local function TokenWindowsReward()
	for player in players.iterate
		P_GivePlayerRings(player, 50) // It's raining rings if Windows touches the token with all emeralds collected.
		S_StartSound(player.mo, sfx_cdfm67, player)
	end
end

local function Token2GemSFX()
	S_StartSound(nil, sfx_marioa)
end

// Redefining these functions to allow for stacking of the timers.
// For both when the Growth replication is on or off.
function A_SuperSneakers(actor)
	if actor.target.skin != "windows" then super(actor) return end
	if mobjscale.value == 1
		if actor.target.player.powers[pw_super] != 0 then
			actor.target.player.powers[pw_sneakers] = $ + sneakertics + 1
			if not (actor.target.player.isxmomentum != nil and actor.target.player.hyper and actor.target.player.hyper.capable) then
				S_ChangeMusic("KGROW", true, actor.target.player)
				S_StartMusicCaption("Growth Powerup", actor.target.player.powers[pw_sneakers], actor.target.player)
			end
		elseif actor.target.player.powers[pw_super] == 0 then
			actor.target.player.powers[pw_sneakers] = $ + ((3*sneakertics) / 5) + 1
			S_ChangeMusic("KGROW", true, actor.target.player)
			S_StartMusicCaption("Growth Powerup", actor.target.player.powers[pw_sneakers], actor.target.player)
		end
		S_StartSound(actor.target.player.mo, sfx_kc5a)
	else
		actor.target.player.powers[pw_sneakers] = $ + sneakertics + 1
		if actor.target.player.powers[pw_super] == 0 then
			P_PlayJingle(actor.target.player, JT_SHOES)
			S_StartMusicCaption("Speed Shoes", actor.target.player.powers[pw_sneakers], actor.target.player)
		end
	end
end

function A_Invincibility(actor)
	if actor.target.skin != "windows" then super(actor) return end
	actor.target.player.powers[pw_invulnerability] = $ + invulntics + 1
	if mobjscale.value == 1 and actor.target.player.powers[pw_sneakers] != 0 then return
	elseif actor.target.player.powers[pw_super] != 0 then return
	else
		P_PlayJingle(actor.target.player, JT_INV);
		S_StartMusicCaption("Invincibility", actor.target.player.powers[pw_invulnerability], actor.target.player)
	end
end

function A_RingBox(actor)
	if actor.target.skin != "windows" then super(actor) return end
	if actor.target.player.winpopup > (15*TICRATE - 5*TICRATE/2) and actor.target.player.winpopup != 15*TICRATE then
		actor.target.player.winpopup = 15*TICRATE - 1
		if not S_SoundPlaying(actor.target.player.mo, sfx_winrbt) then
			S_StartSound(actor.target.player.mo, sfx_winrbt)
		end
	elseif actor.target.player.winpopup < (15*TICRATE - 5*TICRATE/2) then
		actor.target.player.winpopup = $ + 5*TICRATE/2
	end
	super(actor)
end

addHook("PlayerSpawn", function(player)
	player.winpopup = 15*TICRATE
	player.cpanel = 0
	player.xpcooldown = 60*TICRATE
	player.fundeath = 0
end)

addHook("TouchSpecial", function(special)
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
		elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
			if player.winpopup < (15*TICRATE - TICRATE/4) then player.winpopup = $ + TICRATE/4
			elseif player.winpopup > (15*TICRATE - 3*TICRATE/4) and player.winpopup != 15*TICRATE then
				player.winpopup = 15*TICRATE - 1
				if not S_SoundPlaying(player.mo, sfx_winrbt) then
					S_StartSound(player.mo, sfx_winrbt)
				end
			end
		end
	end
end, MT_RING)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then
		if mobjscale.value == 1 and player.powers[pw_sneakers] != 0 and player.mo.destscale > FRACUNIT then
			player.mo.destscale = FRACUNIT
			P_RestoreMusic(player)
			P_ResetPlayer(player)
			if player.winpopup == nil then player.winpopup = 15*TICRATE end
			if player.cpanel == nil then player.cpanel = 0 end
			if player.xpcooldown == nil then player.xpcooldown = 60*TICRATE end
			if player.fundeath == nil then player.fundeath = 0 end
		end
		return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// XMomentum stuff.
		if player.isxmomentum != nil then
			if mplayer.value == 1 then player.hassupermusic = true else player.hassupermusic = false end
		end
		if player.isxmomentum == nil or player.normalspeed < skins[player.mo.skin].normalspeed then
			player.normalspeed = skins[player.mo.skin].normalspeed
		elseif not (player.powers[pw_invulnerability] != 0 or player.powers[pw_sneakers] != 0 or player.powers[pw_super] != 0 or player.cpanel != 0) then
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
		if player.winpopup < 15*TICRATE then player.winpopup = $ + 1
		elseif player.winpopup > 15*TICRATE then
			player.winpopup = 15*TICRATE
			if not S_SoundPlaying(player.mo, sfx_winrbt) then
				S_StartSound(player.mo, sfx_winrbt)
			end
		else
			player.winpopup = 15*TICRATE
		end
		if player.winpopup == 15*TICRATE - 1 then
			if directxboost.value == 1 then S_StartSound(player.mo, sfx_winrbt) end
		end
		player.acceleration = skins[player.mo.skin].acceleration
		player.thrustfactor = skins[player.mo.skin].thrustfactor
		player.jumpfactor = skins[player.mo.skin].jumpfactor + (player.speed / 100)
		player.mo.destscale = FRACUNIT
		if (player.speed > 20*FRACUNIT and player.powers[pw_super] == 0) or player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0 or player.cpanel > 0 then
			player.charflags = $ | SF_CANBUSTWALLS // Ram into the wall!
		else
			player.charflags = $ & ~SF_CANBUSTWALLS
		end
		if player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0 then
			if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 4) / 3 then
				player.normalspeed = (skins[player.mo.skin].normalspeed * 4) / 3
			end
			player.acceleration = (skins[player.mo.skin].acceleration * 4) / 3
		elseif player.powers[pw_sneakers] != 0 then
			if mobjscale.value == 1 then
				player.mo.destscale = 2 * FRACUNIT // Grow!
				if player.powers[pw_invulnerability] < player.powers[pw_sneakers] then
					player.powers[pw_invulnerability] = player.powers[pw_sneakers]
				end
			else // Else, not much excitement.
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 5) / 4
			end
		end
		if player.powers[pw_super] != 0 then
			player.charflags = $ | (SF_CANBUSTWALLS | SF_MULTIABILITY)
			player.powers[pw_invulnerability] = 0
			if mobjscale.value == 0 then
				player.powers[pw_sneakers] = 0
			end
			if player.hyper == nil or player.hyper.capable == false then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
				end
				player.acceleration = (skins[player.mo.skin].acceleration * 4) / 3
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 61) / 51
				player.mo.color = SKINCOLOR_SKY
			elseif player.hyper.capable == true then
				// Extreme overclocking by XMomentum! Careful!
				if player.normalspeed < (skins[player.mo.skin].normalspeed * 7) / 4 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 7) / 4
				end
				player.acceleration = (skins[player.mo.skin].acceleration * 3) / 2
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 3) / 2
				player.mo.color = SKINCOLOR_AZURE
			end
		else
			player.charflags = $ & ~SF_MULTIABILITY // No extra jumps if not Super.
		end
		player.powers[pw_underwater] = 100*TICRATE // We already have machines underwater.
		player.powers[pw_spacetime] = 100*TICRATE // And it's cold in space.
		if player.mo.destscale > player.mo.scale then
			if not S_SoundPlaying(player.mo, sfx_kc5a) and player.powers[pw_sneakers] != 0 then
				S_StartSound(player.mo, sfx_kc5a)
			end
		elseif player.mo.destscale < player.mo.scale then
			if not S_SoundPlaying(player.mo, sfx_kc59) and player.powers[pw_sneakers] == 0 then
				S_StartSound(player.mo, sfx_kc59)
			end
		end
		if directxboost.value == 1 then
			if player.cmd.buttons == BT_CUSTOM2 and player.winpopup >= (15*TICRATE - 1) and player.playerstate == PST_LIVE and player.exiting == 0 and P_PlayerInPain(player) == false then
				if player.powers[pw_super] == 0 then
					player.winpopup = 0
				elseif player.powers[pw_super] != 0 then
					player.winpopup = 10*TICRATE
				end
				player.cpanel = $ + 3*TICRATE
				if player.powers[pw_sneakers] != 0 then
					if player.powers[pw_super] != 0 and mobjscale.value == 1 then
						if player.speed < 80*FRACUNIT then
							P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed)
						end
					end
				else
					if player.speed < 40*FRACUNIT then
						P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, player.speed)
					end
				end
				S_StartSound(player.mo, sfx_zoom)
				if player.powers[pw_super] != 0 then S_StartSound(player.mo, sfx_winxbt)
				elseif player.powers[pw_super] == 0 then S_StartSound(player.mo, sfx_wincbt)
				end
			end
		end
		if player.cpanel > 0 and player.playerstate == PST_LIVE then
			if player.exiting != 0 then
				player.cpanel = 0
			end
			P_SpawnGhostMobj(player.mo)
			local r = player.mo.radius/FRACUNIT
			local xy = (P_RandomRange(r, -r)*FRACUNIT)
			local z = (P_RandomKey(player.mo.height/FRACUNIT)*FRACUNIT)
			local smokey = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_SMOKE)
			smokey.colorized = true
			smokey.color = player.mo.color
			if P_PlayerInPain(player) == true then player.cpanel = 0 end
			if player.exiting != 0 then player.cpanel = 0 end
			if player.powers[pw_super] == 0 then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 15) / 8 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 15) / 8
				end
				if player.speed < (skins[player.mo.skin].normalspeed * 15) / 8 and P_IsObjectOnGround(player.mo) then
					P_Thrust(player.mo, player.mo.angle, FRACUNIT)
				elseif player.speed < (skins[player.mo.skin].normalspeed * 15) / 8 and not P_IsObjectOnGround(player.mo) then
					P_Thrust(player.mo, player.mo.angle, FRACUNIT/2)
				end
			elseif player.powers[pw_super] != 0 then
				local xbox = P_SpawnMobj(player.mo.x + xy, player.mo.y + xy, player.mo.z + z, MT_WATERZAP)
				if player.hyper == nil or player.hyper.capable == false then
					if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 2) then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 2)
					end
					if player.speed < (skins[player.mo.skin].normalspeed * 2) and P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, 2*FRACUNIT)
					elseif player.speed < (skins[player.mo.skin].normalspeed * 2) and not P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, FRACUNIT)
					end
				elseif player.hyper.capable == true then
					if player.normalspeed < (skins[player.mo.skin].normalspeed * 5) / 2 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 5) / 2
					end
					if player.speed < (skins[player.mo.skin].normalspeed * 5) / 2 and P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, 3*FRACUNIT)
					elseif player.speed < (skins[player.mo.skin].normalspeed * 5) / 2 and not P_IsObjectOnGround(player.mo) then
						P_Thrust(player.mo, player.mo.angle, 3*FRACUNIT/2)
					end
				end
			end
			player.cpanel = $ - 1
		end
		if player.exiting == (14*TICRATE)/5 then P_PlayVictorySound(player.mo, player) end
		// Transform at any point as long as you have rings and emeralds,
		// regardless of a shield being present. Use wisely.
		if player.cmd.buttons == BT_CUSTOM3 and player.powers[pw_super] == 0 and player.exiting == 0 then
			if player.rings >= 50 and emeralds >= 127 then
				P_DoSuperTransformation(player, false)
			end
		end
		if (player.powers[pw_shield] & SH_FORCE) then
			player.powers[pw_shield] = $ | (SH_PROTECTSPIKE)
		else
			player.powers[pw_shield] = $ & ~SH_PROTECTSPIKE
		end
	end
end)
						
// Token-to-emerald compilation/conversion.
// Will only work with Windows (the character, not your OS).
// The character is not planned for use in NiGHTS special stages,
// so this is implemented as an alternative method of getting emeralds.
addHook("TouchSpecial", function(special)
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
		elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
			if emeralds & EMERALD1 == 0 then
				emeralds = $ | EMERALD1
				Token2GemSFX()
			elseif emeralds & EMERALD2 == 0 then
				emeralds = $ | EMERALD2
				Token2GemSFX()
			elseif emeralds & EMERALD3 == 0 then
				emeralds = $ | EMERALD3
				Token2GemSFX()
			elseif emeralds & EMERALD4 == 0 then
				emeralds = $ | EMERALD4
				Token2GemSFX()
			elseif emeralds & EMERALD5 == 0 then
				emeralds = $ | EMERALD5
				Token2GemSFX()
			elseif emeralds & EMERALD6 == 0 then
				emeralds = $ | EMERALD6
				Token2GemSFX()
			elseif emeralds & EMERALD7 == 0 then
				emeralds = $ | EMERALD7
				Token2GemSFX()
			else TokenWindowsReward() end
			P_KillMobj(special)
			return true
		end
	end
end, MT_TOKEN)

// Script by Katmint.
// Edited w/ variable check.
// Redundant, but, just in case there's other sources of music change.

addHook("MusicChange", function(oldname, newname)
	if consoleplayer then
		local character = skins[consoleplayer.skin].name
		if character != "windows" then return
		elseif character == "windows" then
			if newname == "_super" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				if consoleplayer.isxmomentum != nil and consoleplayer.hyper and consoleplayer.hyper.capable then
					return "HYPWIN"
				else
					return "ERRORMIX"
				end
			elseif newname == "_inv" and consoleplayer.powers[pw_invulnerability] != 0 and mplayer.value != 0 then
				return "WINV"
			elseif newname == "_shoes" and consoleplayer.powers[pw_sneakers] != 0 then
				if mobjscale.value == 1 then return "KGROW"
				elseif mplayer.value != 0 then return "WINFAST"
				end
			elseif newname == "HYPR" and consoleplayer.powers[pw_super] != 0 and mplayer.value != 0 then
				return "HYPWIN"
			elseif oldname == "_1up" then
				if consoleplayer.powers[pw_sneakers] != 0 and mobjscale.value == 1 then
					return "KGROW"
				elseif consoleplayer.powers[pw_sneakers] != 0 and mplayer.value != 0 then
					return "WINFAST"
				elseif consoleplayer.powers[pw_invulnerability] != 0 and mplayer.value != 0 then
					return "WINV"
				end
			elseif newname == "_clear" and mplayer.value != 0 then
				return "WINCLR"
			end
		end
	end
end)